package gui;

/**
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 8, 2002
 * Time: 3:56:10 PM
 * To change this template use Options | File Templates.
 */
import javax.swing.table.*;
import javax.swing.*;
import logic.PhilConst;

public class MyTableModel extends AbstractTableModel {
    final String[] columnNames = {"", "", ""};
    final Object[][] data = {
            {PhilConst.names[0], new Boolean(false), PhilConst.stateMap[0]},
            {PhilConst.names[1], new Boolean(false), PhilConst.stateMap[0]},
            {PhilConst.names[2], new Boolean(false), PhilConst.stateMap[0]},
            {PhilConst.names[3], new Boolean(false), PhilConst.stateMap[0]},
            {PhilConst.names[4], new Boolean(false), PhilConst.stateMap[0]}
        };

	public int getColumnCount() {
	    return columnNames.length;
	}

	public int getRowCount() {
	    return data.length;
	}

	public String getColumnName(int col) {
	    return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
	    return data[row][col];
	}

	/*
	 * JTable uses this method to determine the default renderer/
	 * editor for each cell.  If we didn't implement this method,
	 * then the last column would contain text ("true"/"false"),
	 * rather than a check box.
	 */
	public Class getColumnClass(int c) {
	    return getValueAt(0, c).getClass();
	}

	/*
	 * Don't need to implement this method unless your table's
	 * editable.
	 */
	public boolean isCellEditable(int row, int col) {
	    //Note that the data/cell address is constant,
	    //no matter where the cell appears onscreen.
	    if (col == 1)
	        return true;

	    return false;
	}

	/*
	 * Don't need to implement this method unless your table's
	 * data can change.
	 */
	public void setValueAt(Object value, int row, int col) {
	    if (data[0][col] instanceof Integer
	            && !(value instanceof Integer)) {
	        try {
	            data[row][col] = new Integer(value.toString());
	            fireTableCellUpdated(row, col);
	        } catch (NumberFormatException e) {
	            JOptionPane.showMessageDialog(null,
	                "The \"" + getColumnName(col)
	                + "\" column accepts only integer values.");
	        }
	    } else {
	        data[row][col] = value;
	        fireTableCellUpdated(row, col);
	    }
	}
}
